
            var hideTrackInfoTimeout;
            var hasAlbumArt = false;
            var goingPrevious = false;
            var updateTimeInterval = 0;
            var hideVolumeTimeout = 0;
            var dragging = false;
            var overTrack = false;
            var isPaused = false;
            var lyricsSetting = "false";
            var visualizationSetting = "true";
            
        function loadSettings() {
            var shuffleSetting = System.Gadget.Settings.read("shuffle");
            var repeatSetting = System.Gadget.Settings.read("repeat");
            var autoStartSetting = System.Gadget.Settings.read("autoStart");
            var volumeSetting = System.Gadget.Settings.read("volume");
            var muteSetting = System.Gadget.Settings.read("mute");
            visualizationSetting = System.Gadget.Settings.read("visualization");
            
            player.settings.setMode( "shuffle", shuffleSetting == "" || shuffleSetting == "true" );
            player.settings.setMode( "loop", repeatSetting == "" || repeatSetting == "true" );
            player.settings.autoStart = autoStartSetting == "" || autoStartSetting == "true";
            player.settings.volume = volumeSetting == "" ? 50 : volumeSetting;
            player.settings.mute = muteSetting == "true";
            
           loadLyrics();
            
            if (visualizationSetting == "false")
                player.style.visibility = "hidden";
            else
                player.style.visibility = "visible";
                
        }
        
        function ToggleLyrics()
        {
            System.Gadget.Settings.write("lyrics", (System.Gadget.Settings.read("lyrics") == "true") ? "false" : "true");
            loadLyrics();
        }
        
        function loadLyrics()
        {
            lyricsSetting = System.Gadget.Settings.read("lyrics");
            
            if (lyricsSetting == "true")
                document.getElementById("lyrics").style.display = "block";
            else
                document.getElementById("lyrics").style.display = "none";
        
        
            if (lyricsSetting == "true")
            {
                document.getElementById("lyrics").innerHTML = "Loading...";
            
                var url = "http://www.lyricsplugin.com/plugin/?artist=" + escape(mediaArtist.innerHTML) + "&title=" + escape(mediaName.innerHTML);
                //System.Debug.outputString("Url: " + url);
                
                 xmlhttp.open("GET", url,true);
                 xmlhttp.onreadystatechange=function() {
                  if (xmlhttp.readyState==4)
                  {
                        var html = xmlhttp.responseText;
                        var index = html.indexOf("\"lyrics\">");
                        var endIndex = html.indexOf("</div>", index);
                        
                        var lyrics = html.substring(index + 9, endIndex);
                        
                        while(lyrics.indexOf("<br />") > -1)
                        {
                            lyrics = lyrics.replace("<br />", "\r\n");
                        }
                        
                        lyrics = "<a href='JavaScript:ToggleLyrics();' style='color:white;' title='Close Lyrics'>X</a>" + lyrics;
                        
                        document.getElementById("lyrics").innerHTML = lyrics;
                  }
                 }
                 xmlhttp.send(null);
            }
        }
        
        var xmlhttp=false;
        /*@cc_on @*/
        /*@if (@_jscript_version >= 5)
        // JScript gives us Conditional compilation, we can cope with old IE versions.
        // and security blocked creation of the objects.
         try {
          xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
         } catch (e) {
          try {
           xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
          } catch (E) {
           xmlhttp = false;
          }
         }
        @end @*/
        if (!xmlhttp && typeof XMLHttpRequest!='undefined') {
	        try {
		        xmlhttp = new XMLHttpRequest();
	        } catch (e) {
		        xmlhttp=false;
	        }
        }
        if (!xmlhttp && window.createRequest) {
	        try {
		        xmlhttp = window.createRequest();
	        } catch (e) {
		        xmlhttp=false;
	        }
        }

        
        
        
        

            function onKeyPress()
            {
                //System.Debug.outputString("event.keyCode: " + event.keyCode);

                var keyID = event.keyCode;

                switch(keyID)
                {
                    case 37: // Arrow Left
                        previous();
                        break;

                    case 39: // Arrow Right
                        next();
                        break;

                    case 38: // Arrow Up
                        next();
                        break;

                    case 40: // Arrow Down
                        next();
                        break;
                        
                    case 80:
                    
                        if (isPaused)
                            play();
                        else
                            pause();
                        break;
                        
                    case 76:
                    
                        ToggleLyrics();
                    
                        break;
                }
            }


           function stop()
            {
                isPaused = false;
                player.controls.stop();
            }

            function play()
            {
                isPaused = false;
                player.controls.play();
            }

            function next() {
                player.controls.next();
            }

            function previous() {
                goingPrevious = true;
                player.controls.previous();
            }
            
            function pause()
            {
                isPaused = true;
                player.controls.pause();
            }
            
            function onLoad() {
                System.Gadget.Flyout.file = "Playlist.html";
                System.Gadget.settingsUI = "Settings.html";
                System.Gadget.onSettingsClosed = loadSettings;
                                
                player.uiMode = "none";
                player.windowlessVideo = true;
                
                loadSettings();

                var nowPlaying;
                if (player.playlistCollection.getByName( "Gadget Now Playing" ).count == 0) {
                    nowPlaying = player.playlistCollection.newPlaylist( "Gadget Now Playing" );
                    if (player.playlistCollection.getByName( "All Music" ).count == 1) {
                        var allMusic = player.playlistCollection.getByName( "All Music" ).item( 0 );
                        for (var i = 0; i < allMusic.count; i++) {
                            nowPlaying.appendItem( allMusic.item( i ) );
                        }
                    }
                } else {
                    nowPlaying = player.playlistCollection.getByName( "Gadget Now Playing" ).item( 0 );
                }
                
                player.currentPlaylist = nowPlaying;
                loadSettings();
                
                updateVolumeDisplay();
            }
            
            function getAuthorString( media ) {
                var authorCount = media.getAttributeCountByType( "Author", "" );
                var authorString = "";
                for (var i = 0; i < authorCount; i++) {
                    authorString += media.getItemInfoByType( "Author", "", i );
                    if (i + 1 < authorCount) authorString += ";";
                }
                
                return authorString;
            }
            
            function getTimeString( time ) {
                var hours = Math.floor( time / 3600 );
                var minutes = Math.floor( (time % 3600) / 60 );
                var seconds = Math.floor( time % 60 );
                
                var timeString = "";
                if (time >= 3600) timeString = hours + ":";
                timeString += (hours > 0 && minutes < 10 ? "0" : "" ) + minutes + ":" + (seconds < 10 ? "0" : "" ) + seconds;
                
                return timeString;
            }
            
            function openPlaylist() {
                System.Gadget.Flyout.show = !System.Gadget.Flyout.show;
            }
            
            function setTrackPercent( percent ) {
                trackFill.style.width = Math.round( percent * 100 ) + "%";
                trackThumb.style.left = Math.round( percent * (trackThumb.offsetParent.offsetWidth - trackThumb.offsetWidth)) + "px";
                mediaTime.innerHTML = 
                        getTimeString( Math.round( player.currentMedia.duration * percent ) ) + " / " +
                        getTimeString( player.currentMedia.duration );
            }
            
            function updateTime() {
                if (dragging) return;
                var trackFill = document.getElementById("trackFill");
                var trackThumb = document.getElementById("trackThumb");
                var mediaTime = document.getElementById("mediaTime");
                
                var percent = 0;
                if (player.currentMedia) {
                    mediaTime.innerHTML = 
                        getTimeString( player.controls.currentPosition ) + " / " +
                        getTimeString( player.currentMedia.duration );
                        
                    
                    percent = player.controls.currentPosition / player.currentMedia.duration;
                } else {
                    mediaTime.innerHTML = "";
                }
                
                if (!dragging) {
                    setTrackPercent( percent );
                }
            }
            
            function onTrackOver() {
                overTrack = true;
                var trackThumb = document.getElementById("trackThumb");
                if (!trackThumb.animator) trackThumb.animator = new Animator( trackThumb );
                trackThumb.animator.fadeIn( 0.2 );
            }
            
            function onTrackOut() {
                overTrack = false;
                
                if (dragging) {
                    window.event.cancelBubble = true;
                    return;
                }
                
                var trackThumb = document.getElementById("trackThumb");
                if (!trackThumb.animator) trackThumb.animator = new Animator( trackThumb );
                trackThumb.animator.fadeOut( 0.4 );
            }
            
            function getPercentFromX( x ) {
                var track = document.getElementById("track");
                var trackThumb = document.getElementById("trackThumb");
                return Math.min( 1, Math.max( 0, (x - track.offsetLeft - 6) / (track.offsetWidth - trackThumb.offsetWidth) ) );
            }
            
            function onTrackUp() {
                dragging = false;
                player.controls.currentPosition = getPercentFromX( window.event.clientX ) * player.currentMedia.duration;
                updateTime();
            }
            
            function onTrackThumbDown() {
                dragging = true;
            }
            
            function onMouseUp() {
                if (dragging) {
                    dragging = false;
                    
                    player.controls.currentPosition = getPercentFromX( window.event.clientX ) * player.currentMedia.duration;
                    updateTime();
                    if (!overTrack) onTrackOut();
                }
            }
            
            function onMouseMove() {
                if (!dragging) return;
                
                setTrackPercent( getPercentFromX( window.event.clientX ) );
            }

            function onBackgroundOut() {
                if (dragging) {
                    dragging = false;
                    updateTime();
                    onTrackOut();
                }
            }
            
            function onVolumeOver() {
                if (document.getElementById( "volume_popup" ).style.visibility == "visible") return;
                var volumeHover = document.getElementById( "volume_hover" );
                volumeHover.src = "images/volume_hover.png";
                volumeHover.style.visibility = "visible";
            }
            
            function onVolumeOut() {
                if (document.getElementById( "volume_popup" ).style.visibility == "visible") return;
                var volumeHover = document.getElementById( "volume_hover" );
                volumeHover.src = "images/volume_hover.png";
                volumeHover.style.visibility = "hidden";
            }
            
            function onVolumeDown() {
                if (document.getElementById( "volume_popup" ).style.visibility == "visible") return;
                var volumeHover = document.getElementById( "volume_hover" );
                volumeHover.src = "images/volume_down.png";
                volumeHover.style.visibility = "visible";
            }
            
            function onVolumeUp() {
                if (document.getElementById( "volume_popup" ).style.visibility == "visible") return;
                var volumeHover = document.getElementById( "volume_hover" );
                volumeHover.src = "images/volume_hover.png";
                volumeHover.style.visibility = "visible";
            }
            
            function onVolumeClick() {
                if (document.getElementById( "volume_popup" ).style.visibility == "hidden")
                    showVolumePopup();
                else
                    hideVolumePopup();
            }
            
            
            
            
            function onLyricsOver()
            {
                var volumeHover = document.getElementById( "lyrics_hover" );
                volumeHover.src = "images/volume_hover.png";
                volumeHover.style.visibility = "visible";
            }
            
            function onLyricsOut() {
                var volumeHover = document.getElementById( "lyrics_hover" );
                volumeHover.src = "images/volume_hover.png";
                volumeHover.style.visibility = "hidden";
            }
            
            function onLyricsDown() {
//                var volumeHover = document.getElementById( "lyrics_hover" );
//                volumeHover.src = "images/volume_down.png";
//                volumeHover.style.visibility = "visible";
            }
            
            function onLyricsUp() {
//                var volumeHover = document.getElementById( "lyrics_hover" );
//                volumeHover.src = "images/volume_hover.png";
//                volumeHover.style.visibility = "visible";
            }
            
            function onLyricsClick()
            {
                ToggleLyrics();
            }
            
            function updateVolumeDisplay() {
                var volume = player.settings.volume;
                var volumeThumb = document.getElementById( "volumeThumb" );
                document.getElementById("volumeTrackFill").style.width = volume + "%";
                volumeThumb.style.left = Math.round( (volume * 0.01) * (volumeThumb.offsetParent.offsetWidth - volumeThumb.offsetWidth)) + "px";
                
                var mute = document.getElementById( "mute" );
                mute.src = player.settings.mute ? "images/mute_down.png" : "images/mute.png";

                var volumeImg = document.getElementById("volume");
                if (player.settings.mute) {
                    volumeImg.src = "images/volume_muted.png";
                } else if (volume == 0) {
                    volumeImg.src = "images/volume_0.png";
                } else if (volume <= 33) {
                    volumeImg.src = "images/volume_33.png";
                } else if (volume <= 66) {
                    volumeImg.src = "images/volume_66.png";
                } else {
                    volumeImg.src = "images/volume_100.png";
                }
            }
            
            function showVolumePopup() {
                updateVolumeDisplay();
                
                var volumePopup = document.getElementById( "volume_popup" );
                volumePopup.style.visibility = "visible";
                
                var volumeHover = document.getElementById( "volume_hover" );
                volumeHover.src = "images/volume_down.png";
                volumeHover.style.visibility = "visible";
            }

            function hideVolumePopup() {
                var volumePopup = document.getElementById( "volume_popup" );
                volumePopup.style.visibility = "hidden";

                var volumeHover = document.getElementById( "volume_hover" );
                volumeHover.style.visibility = "hidden";
            }
            
            function getVolumeFromX( x ) {
                var volumePopup = document.getElementById( "volume_popup" );
                var volumeTrack = document.getElementById("volumeTrack");
                var volumeThumb = document.getElementById("volumeThumb");
                return Math.min( 1, Math.max( 0, (x - volumeTrack.offsetLeft - volumePopup.offsetLeft - 6) / (volumeTrack.offsetWidth - volumeThumb.offsetWidth) ) ) * 100;
            }
            
            function onVolumeTrackMove() {
                if (window.event.button) {
                    player.settings.volume = getVolumeFromX( window.event.clientX );
                    System.Gadget.Settings.write("volume", player.settings.volume);
                    updateVolumeDisplay();
                }
            }
            
            function onMuteClick() {
                player.settings.mute = !player.settings.mute;
                System.Gadget.Settings.write("mute", player.settings.mute ? "true" : "false" );
                updateVolumeDisplay();
            }
            
            function setHideVolumeTimeout() {
                if (hideVolumeTimeout > 0) clearTimeout( hideVolumeTimeout );
                hideVolumeTimeout = setTimeout( onHideVolumeTimeout, 1000 );
            }
            
            function clearHideVolumeTimeout() {
                if (hideVolumeTimeout > 0) clearTimeout( hideVolumeTimeout );
                hideVolumeTimeout = 0;
            }
            
            function onHideVolumeTimeout() {
                hideVolumePopup();
                hideVolumeTimeout = 0;
            }